%{

/* diacs.ll
 * lex file for converting ss into sharp s; it is assumed that the
 * imput file contains umlaut characters.
 */

%}


%p 6500
%n 1100
%e 2500
%a 4000
%k 2500
%o 3500
 
 
V       [AEIOUaeiou]
nV      [^AEIOUaeiou]
C       [B-DF-HJ-NP-TV-Zb-df-hj-np-tv-z]
W       [ "'\t\n,;!?().-]
b       [ \t\n]

%%

\\begin\{.+\}	ECHO;
\\end\{.+\}	ECHO;
\\[A-Za-z]+	ECHO;


         \{\}ss         printf("");
         s\{\}s         printf("ss");

          Gauss/[^s]    ECHO;  
          Neuss         ECHO;
          Zeuss         ECHO;
     Augustinus         ECHO; 
     Bonifatius         ECHO; 
      Stephanus         ECHO; 
      Cornelius         ECHO;
       {W}Rossi         ECHO;
       Jessica          ECHO;

         Bambus         ECHO;
        Bahnbus         ECHO;
         Taunus         ECHO;
         Kaktus         ECHO; 
         Pathos         ECHO; 

         Vulkan         ECHO; 
         Fan            ECHO; 
      Gesetzes          ECHO;

         Cessna         ECHO;
         Degussa        ECHO;
         Tass           ECHO;
      {W}Sssmuth       ECHO;
 
       Business         printf("Busine");
       Fairness         printf("Fairne");
        Fitness         printf("Fitne");


        [Pp]asswd       ECHO;
        [Pp]assword     ECHO;
       [Cc]lass         ECHO;
      [Aa]ccess         ECHO;
     [Ss]uccess         ECHO;
     [Pp]rocess         ECHO;
        rincess         ECHO;
        [ln]ess/{W}     ECHO;
     [Aa]ddress         ECHO;
       [Ff]ress/[^e]    printf("%cre",yytext[0]);
    [Cc]ongress         ECHO;
    [Pp]rogress         ECHO;
          Message       ECHO;
    {W}[Pp]ress/{W}     ECHO;
    [Ss]uppress         ECHO;
     [Dd]epressiv       ECHO;
     [Pp]ossessiv       ECHO;
       [Cc]ross         ECHO;



         ions          ECHO;
     [Ss]inus          ECHO; 

           lass'       ECHO;
             ss/{W}    printf("");

          {V}ssner     ECHO;
          {V}ss[bdfghjklmnrsvwz]  printf("%c%c",yytext[0],yytext[3]);
            osspl      printf("opl");

         [a]sst/[^ru]  printf("%ct",yytext[0]);
     [Vv]ergassen      printf("%cergaen",yytext[0]);
        [Hh]asserf     printf("%caerf",yytext[0]); 
      [Gg]efsse       printf("%cefe",yytext[0]);
         eglassb       printf("eglab");
       [Gg]las         ECHO;
           lass/{C}    printf("la");
           lassunt     printf("launt");
        [mM]ss        printf("%c",yytext[0]);
        {W}Masse/{W}   printf("%cMae",yytext[0]);
        {W}massen/{W}  printf("%cmaen",yytext[0]);
      [Bb]emassen      printf("%cemaen",yytext[0]);
     [Bb]eimassen      printf("%ceimaen",yytext[0]);
      [ut]smasse       printf("%csmae",yytext[0]);
     [Mm]utmasse       printf("%cutmae",yytext[0]);
        [Mm]assa[nr]   printf("%caa%c",yytext[0],yytext[5]);
        Erd            ECHO;
       Land            ECHO;
     Gerll            ECHO;
     [dflh]massen      printf("%cmaen",yytext[0]);
        genmasse       printf("genmae");
     lchenmasse       printf("lchenmae");
     gendermassen      printf("gendermaen");
   [bd]enermassen      printf("%cenermaen",yytext[0]);
    kanntermassen      printf("kanntermaen");
     ientermassen      printf("ientermaen");
      rtermassen      printf("rtermaen");
   [sg]enermassen      printf("%cenermaen",yytext[0]);
     inigermassen      printf("inigermaen");
   [il]chermassen      printf("%cchermaen",yytext[0]);
     wissermassen      printf("wissermaen");
  {W}[Dd]ermassen      printf("%c%cermaen",yytext[0],yytext[1]);
      [Aa]nmassen      printf("%cnmaen",yytext[0]);
    [Aa]nzumassen      printf("%cnzumaen",yytext[0]);
           massung     printf("maung");
           Pass/am     printf("Pa");
           Pass/{C}    printf("Pa");
       [sS]pass/[^a]   printf("%cpa",yytext[0]);
       [sS]psse       printf("%cpe",yytext[0]);
       [Ff]rasse[ns]   printf("%crae%c",yytext[0],yytext[6]);
       [Gg]rasste      ECHO;
        sstrass        printf("sstra");
    {V}ssstrass        printf("%cstra",yytext[0]);
      [sS]trass        printf("%ctra",yytext[0]);
          frssig      printf("frig");
         Elsass        printf("Elsa");
       [^n]sassen      printf("%csaen",yytext[0]);
        [Ss]sse/[^r]  printf("%ce",yytext[0]);

        {W}Essling     ECHO;
     {W}[eE]ss{C}      printf("%c%c%c",yytext[0],yytext[1],yytext[4]);
[^dgHhPpRrsW][e]ssi/[^aegnov] printf("%c%ci",yytext[0],yytext[1]);
        [Ee]ssunl      printf("%cunl",yytext[0]);
        [Ee]sseck      printf("%ceck",yytext[0]);
    [Mm][ae]ssein      printf("%c%cein",yytext[0],yytext[1]);
       [Mm]esserg      printf("%ceerg",yytext[0]);
       [Mm]essin[st]   printf("%cein%c",yytext[0],yytext[6]);
       [Mm]essung      ECHO;
       [Mm]esseleit    ECHO;
          Messel       printf("Meel");
          Messentf     printf("Meentf");
          Messmer      ECHO;
          Mess/[^ei]   printf("Me");
   [^dDKk]iess         printf("%cie",yytext[0]);
      [^h]resste       printf("%crete",yytext[0]);
     [Aa]dressat       ECHO;
     [Aa]dresse/{W}    ECHO;
     [Aa]dressen/[^t]  ECHO;
     [Aa]dressier      ECHO;
     [Aa]dress         printf("%cdre",yytext[0]);
       ongressend      printf("ongreend");
       ongress/[^e]    printf("ongre");
          resst/[^aeiur]  printf("ret");
          Wessi        ECHO;
         kzessor       ECHO;
   [Pp]rozessorien     printf("%crozeorien",yytext[0]);
   [Pp]rozessordn      printf("%crozeordn",yytext[0]);
    [Pp]rozessor       ECHO;
          zessua       ECHO;
          zess/[^ei]   printf("ze");

       Beweis          ECHO;
      Hinweis          ECHO;
[bBgGhHlL]eiss         printf("%cei",yytext[0]);
         Reissalat     ECHO; 
     [Pp]reisselbeer   printf("%creielbeer",yytext[0]);
        Kreisss        printf("Kreis");
        Kreisstrass    printf("Kreisstra");
   [kKpP]reiss         ECHO;
      [rR]eissch[nl]   ECHO;
      [wW]eissag       ECHO;
        eweiss{C}      ECHO;
         Weissr        printf("Weir");
  [mMwWrR]eiss         printf("%cei",yytext[0]);
       [Kk]iss{W}      ECHO;
       [mM]issach      printf("%ciach",yytext[0]);
       [mM]isser       printf("%cier",yytext[0]);
     [rzmM]iss{nV}     printf("%ci%c",yytext[0],yytext[4]);
       {W}Miss/{W}     ECHO;
    {W}[Ww]iss.        ECHO;
           isst/{W}    printf("it");

         mboss/[^e]    printf("mbo");
         blsste       printf("blte");
      [Bb]lsse        printf("%cle",yytext[0]);
      [Bb]loss/[ef]    printf("%clo",yytext[0]);
       Schlosses       ECHO;
        chlossart      printf("chloart");
        chlosshn      printf("chlohn");
       Schloss         printf("Schlo");
       [lL]ssend      printf("%cend",yytext[0]);
       [lL]ss/[^et]   printf("%c",yytext[0]);
        nflssen       printf("nflen");
          lsser       ECHO;
    {W}[rR]oss/[^ei]   printf("%c%co",yytext[0],yytext[1]);
         Grossru       printf("Groru");
         Grossist      ECHO;
      [gG]ross         printf("%cro",yytext[0]);
      [gG]rss         printf("%cr",yytext[0]);
       [sS]oss         printf("%co",yytext[0]);
          toss         printf("to");
       [tT]ss         printf("%c",yytext[0]);

       [aA]ussenden    ECHO;
          Aussendung   ECHO;
          aussende[nt] ECHO;
     Aussenmasse       printf("Auenmae");
   {W}Innenmasse       printf("%cInnenmae",yytext[0]);
     [aA]usse[nr]    printf("%cue%c",yytext[0],yytext[5]);

          ausschenk    ECHO;
          Busstati     ECHO;
       [Bb]usstru      ECHO;
       [bB]ss         printf("%c",yytext[0]);
      atenbusse        ECHO;
      [dn]busse        printf("%cbue",yytext[0]);
      [rR]euss         printf("%ceu",yytext[0]);
       [fF]uss         printf("%cu",yytext[0]);
       [fF]ussel       ECHO;
       [fF]sse        printf("%ce",yytext[0]);
       [Gg]usse[ir]    printf("%cue%c",yytext[0],yytext[5]);
      [Ss]chusse        ECHO;
         chuss         printf("chu");
          lussein      printf("luein");
          lusserk      printf("luerk");
   [Ee]influsse        ECHO;
          luss/[^e]    printf("lu");
         flussen       ECHO;
        [Ff]lusses     ECHO;
         flussung      ECHO;
      [Ff]luss         printf("%clu",yytext[0]);
        chlussend      printf("chluend");
        chlussex       printf("chluex");
       [Mm]ssen       ECHO;
         smusse        ECHO;
       [Mm]usse/[^l]   printf("%cue",yytext[0]);
        Senussi        ECHO;
     [GgNn]uss/[^e]    printf("%cu",yytext[0]);
        Borusse        ECHO;
       ungrusse        ECHO;
       jetrusse        ECHO;
          russen       printf("ruen");
       [Rr]ussend      printf("%cuend",yytext[0]);
       [Rr]ussung      printf("%cuung",yytext[0]);
       [Rr]ussig       printf("%cuig",yytext[0]);
      [gG]rss         printf("%cr",yytext[0]);
       [Ss]ss         printf("%c",yytext[0]);
           sst        printf("t");
     [Ll]uxus          ECHO; 
      [^aA]usst        printf("%cut",yytext[0]); 
 
 [sSfFnNmM]ss/[^e]    printf("%c",yytext[0]);


 
sschen          printf("chen");
